local VERSION = tonumber(("$Revision: 31430 $"):match("%d+"))

local PitBull = PitBull
local PitBull_Highlight = PitBull:NewModule("Highlight", "AceEvent-2.0", "AceConsole-2.0")
local self = PitBull_Highlight
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-30 18:57:07 -0400 (Fri, 30 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

local UnitIsUnit = UnitIsUnit

PitBull_Highlight:RegisterPitBullChildFrames('highlight')

function PitBull_Highlight:OnEnable(first)
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function PitBull_Highlight:PLAYER_TARGET_CHANGED()
	if UnitExists('target') then
		local mouseFocus = GetMouseFocus()
		for unit, frame in PitBull:IterateUnitFrames() do
			if unit:find('target$') then
			elseif UnitIsUnit(unit, 'target') then
				frame.highlight:Show()
			elseif frame ~= mouseFocus then
				frame.highlight:Hide()
			end
		end
	else
		local mouseFocus = GetMouseFocus()
		for unit, frame in PitBull:IterateUnitFrames() do
			if frame ~= mouseFocus then
				frame.highlight:Hide()
			end
		end
	end
end

function PitBull_Highlight:OnPopulateUnitFrame(unit, frame)
	local highlight = newFrame("Texture", frame.overlay, "OVERLAY")
	frame.highlight = highlight
	highlight:SetTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	highlight:SetBlendMode("ADD")
	highlight:SetAlpha(0.5)
	highlight:Hide()
	highlight:SetAllPoints(frame)
end

function PitBull_Highlight:OnClearUnitFrame(unit, frame)
	if frame.highlight then
		frame.highlight = delFrame(frame.highlight)
	end
end

function PitBull_Highlight:OnFrameOnEnter(unit, frame)
	if frame.highlight then
		frame.highlight:Show()
	end
end

function PitBull_Highlight:OnFrameOnLeave(unit, frame)
	if (unit:find("target$") or not UnitIsUnit(unit, "target")) and frame.highlight then
		frame.highlight:Hide()
	end
end

function PitBull_Highlight:OnUnknownLayout(unit, frame, name)
	frame.highlight:SetAllPoints(frame)
	local mouseFocus = GetMouseFocus()
	if mouseFocus == frame then
		frame.highlight:Show()
		return
	end
	if unit:find("target$") then
		frame.highlight:Hide()
		return
	end
	if UnitIsUnit(unit, "target") then
		frame.highlight:Show()
		return
	end
	frame.highlight:Hide()
end

wrap(PitBull_Highlight, 'Highlight')
